var hbuilder = require("hbuilderx")
var fs = require("fs")
var os = require("os")
var path = require("path");
var util = require("./util")
var hjson = require("./hjson.min")
var manifestUtil = require("./manifest")
var hx = require("hbuilderx")
var projectutil = require("./projectutil")
var projectResources = require("./projectresources")
const manifest = "manifest.json";

async function _exportwgt(params) {
    try {
        var exportCodeDir = params.exportCodeDir;
        if (!exportCodeDir) return;
        if (!fs.existsSync(exportCodeDir)) {
            fs.mkdirSync(exportCodeDir,{recursive:true})
        }
        let tmpWgt = os.tmpdir();
        tmpWgt = tmpWgt + "/.wgt/" + params.appid;
        tmpWgt = util.pathReplaceSlash(tmpWgt);
        if (fs.existsSync(tmpWgt)) {
            fs.rmdirSync(tmpWgt,{force:true,recursive:true});
        }
        fs.mkdirSync(tmpWgt,{recursive:true})
        
        var projectDir = params.project;
        if (projectutil.isUniAppVue(params)) {
            projectDir = projectutil.getCompilePath(params);
        }
        
        var manifestFile = projectDir + "/" + manifest;
        
        var readFile = fs.readFileSync(manifestFile, 'utf8');
        var appconfig = hjson.parse(readFile);
        appconfig = manifestUtil.removePluginsByModule(appconfig);
        
        appconfig =  manifestUtil.setManifestDefaultValues(appconfig,manifestFile,params,"ALL",true,false);
        let needConfusion = params.needConfusion;
        
        await projectResources.copyPackAgeResources(params, needConfusion,true,projectDir, tmpWgt, appconfig);
        
        appconfig = manifestUtil.removeConfigNodes(appconfig,needConfusion);
        let data = JSON.stringify(appconfig);
        fs.writeFileSync(tmpWgt + "/" + manifest,data);
        let copyResult = util.copyDirectory(tmpWgt,exportCodeDir);
        fs.rmdirSync(tmpWgt,{force:true,recursive:true});
        return {result:exportCodeDir};
    } catch (e) {
        return {error:e};
    }
}

// 导出
module.exports = {
    exportwgt: _exportwgt
}
